Index: addons/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine/3.3/HeuristicLab.HiveEngine-3.3.csproj
===================================================================
--- addons/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine/3.3/HeuristicLab.HiveEngine-3.3.csproj	(revision 17029)
+++ addons/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine/3.3/HeuristicLab.HiveEngine-3.3.csproj	(revision 17108)
@@ -109,9 +109,7 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="Google.Protobuf, Version=3.6.1.0, Culture=neutral, PublicKeyToken=a7d26565bac4d604, processorArchitecture=MSIL">
-      <HintPath>..\..\packages\Google.Protobuf.3.6.1\lib\net45\Google.Protobuf.dll</HintPath>
-    </Reference>
-    <Reference Include="HEAL.Attic, Version=1.1.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <HintPath>..\..\packages\HEAL.Attic.1.1.0\lib\net461\HEAL.Attic.dll</HintPath>
+    <Reference Include="HEAL.Attic">
+      <HintPath>..\..\..\..\trunk\bin\HEAL.Attic.dll</HintPath>
+      <Private>False</Private>
     </Reference>
     <Reference Include="HeuristicLab.Clients.Hive-3.3">
@@ -127,5 +125,5 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+    <Reference Include="HeuristicLab.Common-3.3">
       <HintPath>..\..\..\..\trunk\bin\HeuristicLab.Common-3.3.dll</HintPath>
       <Private>False</Private>
@@ -137,4 +135,5 @@
     <Reference Include="HeuristicLab.Hive-3.3">
       <HintPath>..\..\..\..\trunk\bin\HeuristicLab.Hive-3.3.dll</HintPath>
+      <Private>False</Private>
     </Reference>
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
@@ -154,7 +153,4 @@
     <Reference Include="System.Data" />
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Drawing.Common, Version=4.0.0.1, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
-      <HintPath>..\..\packages\System.Drawing.Common.4.5.1\lib\net461\System.Drawing.Common.dll</HintPath>
-    </Reference>
     <Reference Include="System.Runtime.Serialization" />
     <Reference Include="System.Windows.Forms" />
@@ -165,11 +161,10 @@
     <Compile Include="Exceptions\ScopeMergeException.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <None Include="packages.config" />
-    <None Include="Plugin.cs.frame" />
     <Compile Include="HiveEngine.cs" />
     <Compile Include="Exceptions\HiveEngineException.cs" />
-    <None Include="Properties\AssemblyInfo.cs.frame" />
   </ItemGroup>
   <ItemGroup>
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+    <None Include="Plugin.cs.frame" />
     <None Include="HeuristicLab.snk" />
   </ItemGroup>
Index: addons/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine/3.3/packages.config
===================================================================
--- addons/HeuristicLab.MetaOptimization/HeuristicLab.HiveEngine/3.3/packages.config	(revision 17029)
+++ 	(revision )
@@ -1,6 +1,0 @@
-﻿<?xml version="1.0" encoding="utf-8"?>
-<packages>
-  <package id="Google.Protobuf" version="3.6.1" targetFramework="net461" />
-  <package id="HEAL.Attic" version="1.1.0" targetFramework="net461" />
-  <package id="System.Drawing.Common" version="4.5.1" targetFramework="net461" />
-</packages>
Index: addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/HeuristicLab.Problems.MetaOptimization-3.3.csproj
===================================================================
--- addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/HeuristicLab.Problems.MetaOptimization-3.3.csproj	(revision 17029)
+++ addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/HeuristicLab.Problems.MetaOptimization-3.3.csproj	(revision 17108)
@@ -76,9 +76,7 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="Google.Protobuf, Version=3.6.1.0, Culture=neutral, PublicKeyToken=a7d26565bac4d604, processorArchitecture=MSIL">
-      <HintPath>..\..\packages\Google.Protobuf.3.6.1\lib\net45\Google.Protobuf.dll</HintPath>
-    </Reference>
-    <Reference Include="HEAL.Attic, Version=1.1.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <HintPath>..\..\packages\HEAL.Attic.1.1.0\lib\net461\HEAL.Attic.dll</HintPath>
+    <Reference Include="HEAL.Attic">
+      <HintPath>..\..\..\..\trunk\bin\HEAL.Attic.dll</HintPath>
+      <Private>False</Private>
     </Reference>
     <Reference Include="HeuristicLab.Algorithms.GeneticAlgorithm-3.3">
@@ -178,7 +176,4 @@
     <Reference Include="System.Core" />
     <Reference Include="System.Drawing" />
-    <Reference Include="System.Drawing.Common, Version=4.0.0.1, Culture=neutral, PublicKeyToken=cc7b13ffcd2ddd51, processorArchitecture=MSIL">
-      <HintPath>..\..\packages\System.Drawing.Common.4.5.1\lib\net461\System.Drawing.Common.dll</HintPath>
-    </Reference>
     <Reference Include="System.Xml.Linq" />
     <Reference Include="System.Data.DataSetExtensions" />
@@ -206,7 +201,4 @@
     <Compile Include="Plugin.cs" />
     <Compile Include="TypeValue.cs" />
-    <None Include="packages.config" />
-    <None Include="Plugin.cs.frame" />
-    <None Include="Properties\AssemblyInfo.cs.frame" />
     <Compile Include="Analyzers\SolutionCacheAnalyzer.cs" />
     <Compile Include="Analyzers\ReferenceQualityAnalyzer.cs" />
@@ -264,4 +256,6 @@
   <ItemGroup>
     <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
   </ItemGroup>
   <ItemGroup>
Index: addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/packages.config
===================================================================
--- addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/packages.config	(revision 17029)
+++ 	(revision )
@@ -1,6 +1,0 @@
-﻿<?xml version="1.0" encoding="utf-8"?>
-<packages>
-  <package id="Google.Protobuf" version="3.6.1" targetFramework="net461" />
-  <package id="HEAL.Attic" version="1.1.0" targetFramework="net461" />
-  <package id="System.Drawing.Common" version="4.5.1" targetFramework="net461" />
-</packages>